<?php
/**
 * @package pragyan
 * @copyright (c) 2008 Pragyan Team
 * @license http://www.gnu.org/licenses/ GNU Public License
 * For more details, see README
 */

global $sourceFolder;
$sourceFolder="cms";///<Folder containing all library files
$installFolder = ".";
define("CMS_SETUP", true);
include("./../".$sourceFolder."/config.inc.php");
if(!isset($_GET['pageno']))
	$pageNumber = 1;
else
	$pageNumber = $_GET['pageno'];
global $goForward;
$goForward = false;
global $lastPage;
$lastPage = false;

$top =<<<TOP
<html>
<head>
<title>Pragyan CMS Installation - Page $pageNumber</title>
</head>
<body>
<h1>Pragyan CMS Installation - Page $pageNumber</h1>
TOP;
$body = GeneratePageFromPageNo($pageNumber);
$bottom .= "<br />";
if(!$lastPage) {
	if($goForward)  {
		$pageNumber++;
		$bottom .= "<br /><a href=\"".$_SERVER['SCRIPT_URI']."?pageno=$pageNumber\">Next Page >></a>";
	}
	else
		$bottom .= "<a href=\"javascript:window.location.reload();\">Refresh</a> the page.";
}
$bottom.=<<<BOTTOM
</body>
</html>
BOTTOM;

echo $top.$body.$bottom;
exit();

function GeneratePageFromPageNo($pageNumber) {
	if($pageNumber == 1)	return GeneralInfo();
	if($pageNumber == 2)	return CheckUploadDirPermission();
	if($pageNumber == 3)	return CheckDatabaseAccess();
	if($pageNumber == 4)	return ImportDatabase();
	if($pageNumber == 5)	return OtherConfigOptions();
	if($pageNumber == 6)	return CheckHtaccess();
	if($pageNumber == 7)	return LastPageInfo();
}

function CheckHtaccess() {
	//print_r($_SERVER);
	$urlRequestRootWithFolder = substr($_SERVER['SCRIPT_NAME'], 0, strrpos($_SERVER['SCRIPT_NAME'], '/'));
	$urlRequestRoot = substr($urlRequestRootWithFolder , 0, strrpos($urlRequestRootWithFolder , '/'));
	$urlRequestRoot = ($urlRequestRoot==""?"/":$urlRequestRoot);
	$scriptPathWithFolder = substr($_SERVER['SCRIPT_FILENAME'], 0, strrpos($_SERVER['SCRIPT_FILENAME'], '/'));
	$scriptPath = substr($scriptPathWithFolder , 0, strrpos($scriptPathWithFolder , '/'));
  //Tell him which options to allowoverride in httpd.conf
  //Do a check in an iframe showing cms root and ask him if he sees a page not found. if he does, it means .htaccessnot working.
  $htaccess =<<<HTACCESS
  <h3>Update httpd.conf</h3>
  <p>
  	For Pragyan CMS to work, .htaccess needs to be supported your webserver. <br />
  	For this, the <b>AllowOverride</b> setting in the httpd.conf has to be made <i>Options FileInfo Limit</i> under the relevant <mono>&lt;Directory&gt;</mono> section.<br />
  	The default location of httpd.conf is <mono>/etc/httpd/conf/httpd.conf</mono>, but may be different for you according to your installation.
  	<br /><br />
  	Add the following lines in the httpd.conf of your webserver :
  	<pre><xmp>
  		<Directory "$scriptPath">
  			AllowOverride All
  		</Directory>
  	</xmp></pre>
  	or, simply add <b><mono>AllowOverride All</mono></b> in the <mono>&lt;Directory /var/www/html&gt;</mono> section, if you are not so concerned about security.
  </p>
  <h3>Update .htaccess file</h3>
  <p>
   Open the .htaccess file and
   <ul>
   <li> 
   Search for the line containing your RewriteBase, and make it
   <pre><xmp>
  		RewriteBase	$urlRequestRoot
  	</xmp></pre>
   </li>
   <li> 
   Search for the line <mono>RewriteCond %{REQUEST_URI}</mono>, and make it
   <pre><xmp>
  		RewriteCond %{REQUEST_URI}	^$urlRequestRoot/$
  	</xmp></pre>
   </li>
   </ul>
  </p>
  <h3>Check if the cms is working</h3>
  <p>
  If you encounter a <b>File Not Found</b> message in the iframe below, it means your .htaccess is not working properly and you need to follow one of the above given steps.
  Correct the errors, and click on <a href="javascript:window.location.reload();">Refresh</a><br />
  <br />
  In case you see green box saying "Pragyan CMS Installation Successfull!!" in the iframe below, then you may proceed by clicking on the Next Page link provided at the bottom of the page.
  </p>
  <iframe id="info" width="600px" height="300px" src="$urlRequestRoot/home/install/+install"></iframe>
  
HTACCESS;
	global $goForward;
	$goForward = true;
	return $htaccess;
}

function OtherConfigOptions() {
  //Ask him if he runs a server which can send mails. And if so, what is the mail suffix. (or the mail-id from which the mail must be sent)
  global $sourceFolder;
  $cmsTitle = CMS_TITLE;
  $template = TEMPLATE;
  $sendMail = SEND_MAIL_ON_REGISTRATION;
  $cmsEmail = CMS_EMAIL;
  $language = LANGUAGE;
  if (function_exists('gd_info'))
  {
  $version=gd_info();
  $phpgdsupport= $version['GD Version'];
  }
  else
  $phpgdsupport ="WARNING:phpgd not installed. Not all functions may work properly";

  $configOptions .= <<<WHATEVER
		  <p>
Now you need to update the following settings in $sourceFolder/config.inc.php
</p>
<table border="1">
<caption>Settings</caption>

<tr>
<th>Config Variable</th><th>Current Variable Value</th><th>Description</th>
</tr>

<tr>
<td>CMS_TITLE</td>
<td>$cmsTitle</td>
<td>Title of the cms.</td>
</tr>

<tr>
<td>TEMPLATE</td>
<td>$template</td>
<td>The name of the current template folder.</td>
</tr>

<tr>
<td>SEND_MAIL_ON_REGISTRATION</td>
<td>$sendMail</td>
<td>Specifies whether verification mails should be sent for user registrations.
Make this false if you run a server without email service.
</td>
</tr>

<tr>
<td>CMS_EMAIL</td>
<td>$cmsEmail</td>
<td>The email used for sending cms emails.</td>
</tr>

<tr>
<td>LANGUAGE</td>
<td>$language</td>
<td>Name of the subfolder inside the language folder to be imported.</td>
</tr>
</table>
<br />
These are your system settings</br><table border="1"><tr><th>phpgdversion</th><td>$phpgdsupport</td></tr></table></br>
<p>
	<h4> Configuring MAIL content (Optional) </h4>
	If you want to edit the mail content that is sent to users of your site then edit the files inside : <big><i>$sourceFolder/languages/en</i></big>
	<br /><br />
	FILE INFO: 
	<ul>
	<li> "activation_email.txt" contains the mail to be sent upon activation </li>
	<li> "password_forgot_reset.txt" contains the mail to be sent when the user forgets password and requests a reset </li>
	<li> "password_reset.txt" contains the mail to be sent when the user has changed the password in the 'reset password page' successfully
	</ul>
	</p>
	<br />
WHATEVER;
	$configOptions .="If you are satisfied with the above settings, proceed forward.<br />" .
			"Otherwise update these settings in ".$sourceFolder."/config.inc.php click on <a href=\"javascript:window.location.reload();\">Refresh</a>.";
	global $goForward;
	$goForward = true;

	return $configOptions;

}

function GeneralInfo() {
	$general=<<<GENERAL
	<p>Welcome to Pragyan CMS Installation.</p>
<p>
Just keep going page forward by page by clicking on Next Page.

</p>
GENERAL;
	global $goForward;
	$goForward = true;
	return $general;
}

function LastPageInfo() {
	global $lastPage;
	$lastPage = true;
	$info =<<<INFO
	<p>
	<h3>Congratulations!!! The cms has been setup.</h3><br/>
	Now you can either delete the installation folder (rm -rf INSTALL) <br/>
	OR change its permissions so apache cannot access it (<mono>chmod 700 INSTALL; chown someuser INSTALL</mono>).
	</p>
	<p>
	Now you can login to the cms with the following username and password<br/>
	<b>username:</b> <mono>admin@pragyan.sf.net</mono><br/>
	<b>password:</b> <mono>admin</mono>
	</p>
	
	
	<a href="../">Go to the cms.</a>
INFO;
	return $info;
}

function CheckDatabaseAccess() {
  global $sourceFolder;
	$dblink = mysql_connect(MYSQL_SERVER, MYSQL_USERNAME, MYSQL_PASSWORD);
	$dbaccessInfo = "";
	if(!$dblink) {
		$dbaccessInfo .= <<<WHATEVER
		  <p>To create a database and a user with all priviliges to that database, run the following queries after replacing <b>pragyandatabase</b>, <b>localhost</b>, <b>pragyanuser</b> and <b>pragyanpassword</b> as required. </p>
<pre>
CREATE DATABASE `pragyandatabase` ;
CREATE USER 'pragyanuser'@'localhost' IDENTIFIED BY 'pragyanpassword';
GRANT ALL PRIVILEGES ON `pragyan\_v2` . * TO 'pragyanuser'@'localhost';
</pre>
    <p>After you run these queries successfully in your mysql client, update these setting in the $sourceFolder/config.inc.php file in the mysql section.</p>
<ul>
<li>MYSQL_SERVER</li>
<li>MYSQL_USERNAME</li>
<li>MYSQL_PASSWORD</li>
<li>MYSQL_DATABASE</li>
</ul>

<br/>
    <p>Could not connect to the server. (This means you either haven't run the above queries or haven't updated the $sourceFolder/config.inc.php file.)</p>

WHATEVER;
		return $dbaccessInfo;
	}
	//TODO: check if db is selectable check if this user has permissions
	$dbaccessInfo .="Database set up successfully.";
	global $goForward;
	$goForward = true;

	return $dbaccessInfo;
}

function ImportDatabase() {
	global $installFolder;
	mysql_connect(MYSQL_SERVER, MYSQL_USERNAME, MYSQL_PASSWORD);

	mysql_select_db(MYSQL_DATABASE);

/*	$querytruncate = "SHOW TABLES";
	$result = mysql_query($querytruncate);
	while ($arrtruncate = mysql_fetch_row($result)) {
	  foreach($arrtruncate as $arr) {
	    $querytruncate = "DELETE FROM $arr";
	    $result1 = mysql_query($querytruncate);
	    if(!$result1) {
	      $output = "<h3>Error:</h3><pre>".$querytruncate."</pre>\n<br/>Unable to import the rows. ".mysql_error();
	      return $output;
	    }
	  }
	}
*/

	$handle = @fopen($installFolder."/pragyan_structure.sql", "r");
	if ($handle) {
	  while (!feof($handle)) {
	    $buffer = fgets($handle, 4096);
	    if(!(strpos($buffer,"--")===0))
	      $query.=$buffer;
	  }
	  fclose($handle);
	}
	$query = str_replace("pragyanV2_",MYSQL_DATABASE_PREFIX,$query);
	$singlequeries = explode(";\n",$query);
	foreach ($singlequeries as $singlequery) {
	  if(trim($singlequery)!="") {
	    $result1 = mysql_query($singlequery);
	    if(!$result1) {
	      $output = "<h3>Error:</h3><pre>".$singlequery."</pre>\n<br/>Unable to import the rows. ".mysql_error();
	      return $output;
	    }
	  }
	}

	$handle = @fopen($installFolder."/pragyan_inserts.sql", "r");
	if ($handle) {
	  while (!feof($handle)) {
	    $buffer = fgets($handle, 4096);
	    if(!(strpos($buffer,"--")===0))
	      $query.=$buffer;
	  }
	  fclose($handle);
	}
	$query = str_replace("pragyanV2_",MYSQL_DATABASE_PREFIX,$query);
	$singlequeries = explode(";\n",$query);
	foreach ($singlequeries as $singlequery) {
	  if(trim($singlequery)!="") {
	    $result1 = mysql_query($singlequery);
	    if(!$result1) {
	      $output = "<h3>Error:</h3><pre>".$singlequery."</pre>\n<br/>Unable to import the rows. ".mysql_error();
	      return $output;
	    }
	  }
	}
	$output = "Database imported successfully.";
	global $goForward;
	$goForward = true;
	return $output;
}

function CheckUploadDirPermission() {
	global $goForward;
	$goForward = false;
	global $sourceFolder;
	$cmsfolder = "./../".$sourceFolder;
	if(is_dir($cmsfolder."/uploads"))
	{
		$testFolder=@fopen($cmsfolder."/uploads/testperms",w);
		 if(!$testFolder)
		 {
		 	$dirpermission="Please check the permissions of the <b>$sourceFolder/uploads/</b> folder. It should be writable by your webserver user<br>";
		 	$dirpermission.="<br />On a <i>linux</i> server, after going inside the $sourceFolder folder run the following commands as root<br>";
		 	$dirpermission.="<pre>chown -R <httpd process user> uploads;</pre><br />";
		 	$dirpermission.="<b>OR</b><br /><pre>chmod -R 777 uploads</pre>";
		 }
		 else
		 {

		 	fclose($testFolder);
		 	unlink($cmsfolder."/uploads/testperms");
		 	$dirpermission="Uploads directory set up with proper permissions.";
		 $goForward = true;
		 }
	}
	else
	{
			$dirpermission="Kindly create the <b>$sourceFolder/uploads</b> folder. It should be writable by your webserver user<br>";
		 	$dirpermission.="<br />On a <i>linux</i> server,after going inside the $sourceFolder run the following commands as root<br>";
		 	$dirpermission.="<pre>mkdir uploads</pre><br />";
		 	$dirpermission.="<pre>chown -R <httpd process user> uploads;</pre><br />";
		 	$dirpermission.="<b>OR</b><br /><pre>chmod -R 777 uploads</pre>";

	}
	clearstatcache();
	return $dirpermission;

}


?>
